package core.repositories.timemanager;

import core.entities.User;
import core.entities.timemanager.BasicTaskSchedule;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.time.LocalDate;
import java.util.List;

@Repository
public interface BasicTaskScheduleRepository extends CrudRepository<BasicTaskSchedule, Long> {

    @Modifying
    @Transactional
    @Query(value = "DELETE FROM BasicTaskSchedule bts WHERE bts.scheduleID = ?1")
    void deleteBasicTaskScheduleByID(long id);

    @Query(value = "SELECT bts FROM BasicTaskSchedule bts WHERE bts.task.taskgroup.user = ?1")
    List<BasicTaskSchedule> findAllByUser(User user);

    @Query(value = "SELECT bts FROM BasicTaskSchedule bts WHERE bts.task.taskgroup.user = ?1 AND bts.scheduleDate = ?2")
    List<BasicTaskSchedule> findAllByUserAndDate(User user, LocalDate localDate);
}
