package core.repositories.timemanager;

import core.entities.timemanager.Task;
import core.entities.timemanager.Taskgroup;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;

@Repository
public interface TaskRepository extends CrudRepository<Task, Long> {

    @Transactional
    @Modifying
    @Query(value = "DELETE FROM Task t WHERE t.taskgroup = ?1")
    void deleteAllByTaskgroup(Taskgroup taskgroup);

    @Transactional
    @Modifying
    @Query(value = "DELETE FROM Task t WHERE t.taskID = ?1")
    void deleteByTaskID(long taskID);
}
